package jalview.datamodel;

import jalview.schemes.*;
import jalview.analysis.*;
import jalview.datamodel.*;
import java.util.*;

public class SuperGroup
{
  String groupName;
  boolean displayBoxes;
  boolean displayText;
  boolean colourText;
  public ColourSchemeI cs;
  ArrayList sequenceGroups = new ArrayList();

  public SuperGroup()
  {
    groupName = "Super group";
    this.displayBoxes = true;
    this.displayText = true;
    this.colourText = false;
    cs = null;
  }


  public SuperGroup(String groupName, ColourSchemeI scheme,
                       boolean displayBoxes, boolean displayText,
                       boolean colourText)
     {
       this.groupName = groupName;
       this.displayBoxes = displayBoxes;
       this.displayText = displayText;
       this.colourText = colourText;
       this.cs = scheme;
     }

  public String getName()
  {
    return groupName;
  }

  public void setName(String name)
  {
    groupName = name;
  }


  public void addGroup(SequenceGroup sg)
  {
    if(!sequenceGroups.contains(sg))
      sequenceGroups.add(sg);
  }

  public void addOrRemove(SequenceGroup sg)
  {
    if(sequenceGroups.contains(sg))
      deleteGroup(sg);
    else
      addGroup(sg);
  }

  public void deleteGroup(SequenceGroup sg)
  {
    sequenceGroups.remove(sg);
  }

  public void setSuperGroupProperties(SequenceGroup sg)
  {
    cs = sg.cs;
    colourText = sg.colourText;
    displayText = sg.displayText;
    displayBoxes = sg.displayBoxes;

    for(int i=0; i<sequenceGroups.size(); i++)
    {
      SequenceGroup temp = (SequenceGroup)sequenceGroups.get(i);
      temp.cs = sg.cs;
      temp.colourText = sg.colourText;
      temp.displayText = sg.displayText;
      temp.displayBoxes = sg.displayBoxes;
    }
  }


  public int getSize()
  {
    return sequenceGroups.size();
  }

  public SequenceGroup getGroupeAt(int i)
  {
    return (SequenceGroup) sequenceGroups.get(i);
  }
}
